print "Loading Players..."
from pygame.sprite import Sprite, spritecollide
from pygame.rect import Rect
import pygame #get_pressed
import Graphics_Config, Weapons, Objects, Sounds
import AI
from math import sqrt


from random import randint, choice
def smin(speed, direction):
	if not speed[0] and not speed[1]:
		return direction[0:2]
	else:
		return speed

def sign(n):
	if n < 0: 
		return -1
	elif not n:
		return 0
	else:
		return 1


	

class KeyLayout:
	def __init__(self, right=None, left=None, up=None, down=None,
		fire=None, secondary=None, stop=None, gorgon = None):
		self.right = right
		self.left = left
		self.up = up
		self.down = down
		self.gorgon = gorgon
		self.fire = fire
		self.secondary = secondary
		self.stop = stop
	# This class is done in this bazzare way so as to be self-documenting in Prefs.py.

class Player(Sprite):
	ai_goal = None
	ai_course_timer = 0
	ai_course = [0,0]
	kills = 0
	ai_whacks = 0
	ai_others = {}
	shield = 100
	override_direction = False
	am = 0
	allow_gorgon = False
	bouncey = False
	# Player class..
	def __init__(self, keys, id, spawn, Level, name, type=None):
		self.rect = Rect(*spawn+(24, 24))
		self.image = Graphics_Config.Players[id-1][2][2][0]
		self.images = Graphics_Config.Players[id-1]
		self.speed = [0,0]
		self.keys = keys
		self.id = id
		self.dead = False
		self.collided_block = False
		self.name = name
		self.engine = True
		self.secondary = None
		self.gorf = 0
		self.mtarg = None
		self.gord = 1
		self.ai_predes = None
		self.maxspeed = 3
		self.gorgoned = False
		self.lasthitter = None
		self.Level = Level
		self.enginetimer = 0
		self.lastdamage = 'a bug'
		self.plasmapower = 8
		self.recycle2 = 1
		self.recycle2timer = 0
		self.scount = 0
		self.recycle1 = 20
		self.recycle1timer = 0
		self.direction = [1,1,0]
		self.type = type
		Sprite.__init__(self)
	def go_speed(self, x,y):
		if not x and not y: return
		if abs(self.speed[0]) < self.maxspeed or cmp(x,0) != cmp(self.speed[0],0):
			self.speed[0] += self.engine*x
			self.direction[0] = x
		if abs(self.speed[1]) < self.maxspeed or cmp(y,0) != cmp(self.speed[1],0):
			self.speed[1] += self.engine*y
			self.direction[1] = y
	def fire_primary(self, dir):
		if not self.gorgoned:
			if not self.recycle1timer:
				self.Level.objects.add(Weapons.Plasma(
						smin(self.speed, dir),
						(self.rect.x+6,self.rect.y+6), 
						self.Level, self
						))
				self.recycle1timer = self.recycle1
		else:
			if not dir[1] or not dir[0] or self.recycle1timer: return
			self.Level.effects.add(Objects.Explosion(
				(self.rect.x-96+((dir[0]+1)*64), self.rect.y-96+((dir[1]+1)*64)),
				Graphics_Config.FingerOfGorgon[dir[0]+1][dir[1]+1],
				self.Level
				))
			self.Level.objects.add(Weapons.GorgonBlastZone(
			(200, (48,48)), 
			(self.rect.x+32+(100*dir[0]), self.rect.y+32+(100*dir[1])),
			self.Level, self
			))

			Sounds.GorgonFire.play(1,500)
			self.recycle1timer = self.recycle1

	def fire_secondary(self, dir):
		if self.secondary and not self.recycle2timer and not self.gorgoned:
			self.Level.objects.add(self.secondary(
					smin(self.speed, dir),
					(self.rect.x,self.rect.y), 
					self.Level, self
					))
			self.scount -= 1
			self.recycle2timer = self.recycle2
			if not self.scount:
					self.Level.prnt = "%s has no more %s weapons."%(
						self.name, self.secondary.name
						)
					self.secondary = None
			return True
		elif self.gorgoned:
			if not self.enginetimer: self.am += 1; self.enginetimer = 5
			if self.am == 4: self.am = 0
			print "Gorgon attack mode: %d"%self.am
			return True
		else:
			return False
	def trigger_engine(self):
		if not self.enginetimer:
			self.engine = not self.engine
			if self.gorgoned:
				self.recycle1 = 2
			else:
				self.recycle1 = 15*self.engine+5
			self.plasmapower = 10*(not self.engine)+8
			self.enginetimer = 10



	def update(self):
		if not self.gorgoned: 
			self.Level.effects.add(Objects.TargetDot(
				self.rect.x+12+20*self.direction[0],
				self.rect.y+12+20*self.direction[1],
				self.speed, self
				))
		if self.recycle1timer: self.recycle1timer -= 1
		if self.recycle2timer: self.recycle2timer -= 1
		flag = 0
		if not self.type:
			key = pygame.key.get_pressed()
			if key[self.keys.gorgon] and not self.gorgoned and self.allow_gorgon and not self.enginetimer: self.turn_into_gorgon()
			elif key[self.keys.gorgon] and self.gorgoned and self.allow_gorgon and not self.enginetimer: self.turn_back_to_normal()
			if key[self.keys.stop]: 
				self.trigger_engine()
			self.go_speed(
				(key[self.keys.right]-key[self.keys.left]),
				(key[self.keys.down]-key[self.keys.up])
				)

			if key[self.keys.fire]:
				self.fire_primary(self.direction)
				
			elif key[self.keys.secondary]:# and self.secondary and not self.recycle2timer and self.scount:
				self.fire_secondary(self.direction)
		elif self.type == 1:
			# Mouse control!
			buttons = pygame.mouse.get_pressed()
			pos = pygame.mouse.get_pos()
			if buttons[0]:
				self.fire_primary(self.direction)
			elif buttons[2]:
				self.fire_secondary(self.direction)
			if buttons[1]: 
				self.trigger_engine()
			if pos[0]+2 > self.rect.x+12:
				if self.engine and self.speed[0] < self.maxspeed: self.speed[0] += 1
				self.direction[0] = 1
			elif pos[0]-2 < self.rect.x+12:
				if self.engine and self.speed[0] > -self.maxspeed: self.speed[0] -= 1
				self.direction[0] = -1
			if pos[0] < self.rect.x+19 and pos[0] > self.rect.x+4:
				self.direction[0] = 0
				self.speed[0] = 0
			if pos[1]+2 > self.rect.y+12:
				if self.engine and self.speed[1] < self.maxspeed: self.speed[1] += 1
				self.direction[1] = 1
			elif pos[1]-2 < self.rect.y+12:
				if self.engine and self.speed[1] > -self.maxspeed: self.speed[1] -= 1
				self.direction[1] = -1
			if pos[1] < self.rect.y+12 and pos[1] > self.rect.y-10:
				self.speed[1] = 0
				self.direction[1] = 0
			#self.go_speed(
			#	cmp(pos[0], self.rect.x+12),
			#	cmp(pos[1], self.rect.y+12)
			#	)
		elif self.type == 2:
			# dumb AI!
			if not self.ai_goal or self.ai_attention_span < 0:
				self.ai_attention_span = AI.attention_span
				#print "\n%s is selecting a new goal..."%self.name
				goal = None
				goalW = AI.min
				
				#print "Considering Yummies:"
				for yummie in self.Level.items.sprites():
					distance = sqrt((self.rect.x-yummie.rect.x)**2+(self.rect.y-yummie.rect.y)**2)
					weight = 0
					distfact = int(AI.distance_factor*distance)
					if isinstance(yummie, Objects.WeaponItem):
						if not self.secondary or AI.weapweights[yummie.type] > AI.weapweights[self.secondary.type]:
							weight = AI.weapweights[yummie.type]-distfact
						else:
							weight = AI.min
					elif isinstance(yummie, Objects.SpeedItem):
						weight = AI.speed_value-distfact
					elif isinstance(yummie, Objects.ShieldItem):
						weight = max(0, 120-self.shield) + int(AI.shield_value*yummie.value)-distfact
					elif isinstance(yummie, Objects.Teleporter):
						weight = AI.teleporter_value-distfact
					weight += randint(-AI.randomness,AI.randomness)
					if weight > goalW and yummie != self.ai_predes:
						goalW = weight
						goal = yummie
					#print "\tSaw a %s %d pixels distant: weighted %d."%(yummie.name, distance, weight)

				#print "\nConsidering Players:"
				for player in self.Level.players.sprites():
					if player == self: continue
					distance = sqrt((self.rect.x-player.rect.x)**2+(self.rect.y-player.rect.y)**2)
					distfact = int(AI.distance_factor*distance)
					weight = AI.player_value-(AI.player_shield_weight*(player.shield-self.shield))-distfact
					weight += randint(-AI.randomness,AI.randomness)
					self.ai_others[player.id] = distance
					if weight > goalW and player != self.ai_predes:
						goalW = weight
						goal = player
					#print  "\tSaw %s %d pixels distant: weighted %d."%(player.name, distance, weight)

					
					
				if not goal: goal = self.ai_predes
				#print "%s selected %s at (%d,%d) as a goal. (Weight: %d)"%(
				#	self.name, goal.name, goal.rect.x, goal.rect.y,
				#	goalW
				#	)
				self.ai_goal = goal

			if not self.ai_course_timer:
				self.ai_course = [
					AI.aicmp(self.ai_goal.rect.x, self.rect.x, gen=True),
					AI.aicmp(self.ai_goal.rect.y, self.rect.y, gen=True)
					]
				self.ai_course_timer = AI.course_recompute
				if not self.engine:
					self.trigger_engine()
				#print "\n%s selects a course: %s"%(self.name, self.ai_course)
			if self.collided_block:
				self.ai_whacks += 20
				if self.engine:
					self.trigger_engine()
				if self.ai_whacks > 70:
					#print "\n%s is frustrated with obstruction."%self.name
					self.ai_predes = self.ai_goal
					self.ai_goal = None
					self.ai_whacks = 0
					self.ai_course = choice([[
						self.direction[0]*-1,
						self.direction[1]*-1
						],[
						randint(-1,1),
						randint(-1,1)
						]]
						)
					if not self.engine: self.trigger_engine()
					self.enginetimer = 2
					self.ai_course_timer = 40
				self.collided_block = False
			crsh = AI.going_to_crash(self)
			if self.engine and crsh and not self.secondary is Weapons.Shield:
				self.ai_goal = crsh
				self.ai_course = [
					AI.aicmp(self.ai_goal.rect.x, self.rect.x),
					AI.aicmp(self.ai_goal.rect.y, self.rect.y)
					]
				self.ai_course_timer = 4
				self.trigger_engine()
			elif crsh and (self.secondary is Weapons.Shield or self.secondary is Weapons.PillShot):
				self.fire_secondary(self.ai_course)
				self.ai_goal = crsh
				self.ai_course = [
					AI.aicmp(self.ai_goal.rect.x, self.rect.x),
					AI.aicmp(self.ai_goal.rect.y, self.rect.y)
					]
				self.ai_course_timer = 5


			self.go_speed(*self.ai_course)
			#print "%s Frustration: %d"%(self.name, self.ai_whacks)
			
			if self.ai_goal:
				if self.gorgoned:
					self.fire_primary([
						AI.aicmp(self.ai_goal.rect.x, self.rect.x),
						AI.aicmp(self.ai_goal.rect.y, self.rect.y)
						])
					if not randint(0,5):
						self.fire_secondary(self.direction)

				if not isinstance(self.ai_goal, Player) or not self.secondary or self.ai_whacks > 20:
					self.fire_primary([
						AI.aicmp(self.ai_goal.rect.x, self.rect.x),
						AI.aicmp(self.ai_goal.rect.y, self.rect.y)
						])
				elif self.secondary == Weapons.Polaron or self.secondary == Weapons.Flak or self.secondary == Weapons.Rocket:
					self.ai_course = [
						AI.aicmp(self.ai_goal.rect.x, self.rect.x),
						AI.aicmp(self.ai_goal.rect.y, self.rect.y)
						]
					if not self.fire_secondary(self.ai_course) and self.secondary != Weapons.Rocket: self.fire_primary(self.ai_course)

				elif self.secondary is Weapons.PillShot or self.secondary is Weapons.Nanoids or self.secondary is Weapons.Goobers:
					self.fire_secondary(self.ai_course)
				elif self.secondary == Weapons.Seeker or self.secondary == Weapons.Drone or self.secondary == Weapons.Mine:
					#print "\n%s is considering using Seekers or drones."%self.name
					warn = False
					for player in self.Level.players.sprites():
						dis = sqrt((self.rect.x-player.rect.x)**2+(self.rect.y-player.rect.y)**2)
						if dis < 90: warn = True
					if not warn: 
						self.fire_secondary(self.ai_course)
						self.ai_course = [
							self.direction[0]*-1,
							self.direction[1]*-1
							]
						if not self.engine: self.trigger_engine()
						self.enginetimer = 2
					else:
						pass
						#print "\tDecided against that idea."
			if not randint(0, AI.crazy):
				self.ai_course = [
				randint(-1,1),
				randint(-1,1)
				]

			#self.fire_secondary(self.direction)
			#if not randint(0,160):
			#	self.trigger_engine()


			self.ai_attention_span -= 1
			self.ai_course_timer -= 1
			if self.ai_whacks: self.ai_whacks -= 1
		elif self.type == 4:
			if not self.malfunction[0]: 
				self.type = self.malfunction[1]
				self.Level.prnt = '%s is back to normal. (%d)'%(self.name, self.type)
			self.malfunction[0] -= 1
			if not randint(0,5):
				self.speed = [randint(-2*self.maxspeed,2*self.maxspeed),randint(-2*self.maxspeed,2*self.maxspeed)]
			if not randint(0,10):
				self.fire_primary((randint(-1,1),randint(-1,1)))
			if not randint(0,20):
				self.fire_secondary((randint(-1,1),randint(-1,1)))
		else:
			# Sumo AI
			# Smart AI is `stateful', it has various modes of action.
			if not self.__dict__.has_key('sumobot'):
				tmp = self.Level.players.sprites()
				tmp.remove(self)
				self.target = choice(tmp)
				if self.name == 'Miho':
					self.skill = 9
				else:
					self.skill = randint(1,4)
				self.sumobot = True
			
			if randint(0,9) < self.skill:
				if self.target.shield <= 0:
					print "New target!"
					mp = self.Level.players.sprites()
					mp.remove(self)
					if not mp: 
						self.target = None
					else:
						self.target = choice(mp)

				tmp = AimAt(self, self.target)
				self.speed = [
					sign(tmp[0])*(self.maxspeed-1),sign(tmp[1])*(self.maxspeed-1)
					]
						
		if self.direction[0:2] == [0,0]: self.direction = [0,-1,self.direction[2]]

				

		self.rect.move_ip(self.speed)
		if self.shield <= 0: self.destroy()
		if self.enginetimer: self.enginetimer -= 1
		if not self.engine: self.speed = [0,0]
		if self.gorgoned:
			self.image = self.images[self.gorf]
			self.gorf += self.gord
			if self.gorf == len(self.images)-1 or self.gorf == -1:
				self.gord *= -1
		else:
			self.image = self.images[self.direction[0]+1][self.direction[1]+1][self.engine]
	def destroy(self):
		try:
			self.Level.prnt = "%s's bot was destroyed by %s's %s. (Had %d kills at defeat)"%(
				self.name, self.lasthitter.player.name, self.lasthitter.name, self.kills
				)
			self.lasthitter.player.kills += 1
			print "%s's bot was destroyed by %s. (Had %d kills at defeat)"%(
				self.name, self.lastdamage, self.kills
				)
		except:
			self.Level.prnt = "%s was destroyed by %s!"%(self.name, self.lastdamage)

		i = 0
		m = randint(17,27)
		while i < m:
			self.Level.effects.add(Objects.Shrapnel(
				[self.rect.x,self.rect.y], 
				[randint(-2,2)*self.speed[0], randint(-2,2)*self.speed[1]], 
				Graphics_Config.Shrapnel_Grey, self.Level
				))
			i += 1
		self.Level.effects.add(Objects.Explosion(
			(self.rect.x-22, self.rect.y-22), # may need fixing
			Graphics_Config.PlayerExplode,
			self.Level
			))
		Sounds.PExplode.play()
		self.kill() # Make much fancier.
		self.dead = True
	def turn_into_gorgon(self):
		self.Level.prnt = "Something strange is happening..."
		self.Level.players.remove(self)
		self.Level.effects.add(self)
		self.images = Graphics_Config.Gorgon
		self.gorgoned = True
		self.recycle1timer = 0
		self.recycle1 = 2
		self.recycle2timer = 10000000
		self.rect.x -= 20
		self.rect.y -= 20
		self.dead = True	
		self.engine = True
		self.enginetimer = 10
	def turn_back_to_normal(self):
		self.Level.prnt = "%s's bot is back to normal..."%self.name
		self.Level.effects.remove(self)
		self.Level.players.add(self)
		self.images = Graphics_Config.Players[self.id-1]
		self.gorgoned = False
		self.recycle1timer = 0
		self.rect.x += 20
		self.rect.y += 20
		self.recycle2timer = 0
		self.enginetimer = 10
		self.dead = False


def Dist(shooter, target):
	dx= target.rect.x-shooter.rect.x
	dy= target.rect.y-shooter.rect.y
	return int(sqrt(dx**2+dy**2))

def AimAt(shooter, target):
	if not target: return [1,1]
	dx= target.rect.x-shooter.rect.x
	dy= target.rect.y-shooter.rect.y
	dist = int(sqrt(dx**2+dy**2))/9
	try:
		return [dx/dist+randint(-1,1),dy/dist+randint(-1,1)]
	except:
		return [1,1]


class Pill(Player):
	override_direction = True
	shield = 500
	nan = 0
	old_shield = 400
	def update(self):
		if self.shield < 95: self.shield += 1
		self.image = Graphics_Config.Pill[0]
		if isinstance(self.lasthitter, Weapons.Polaron) or self.shield < 100 and self.nan < 10:
			self.Level.objects.add(Weapons.PillShot(
				AimAt(self, self.mtarg),
				(self.rect.x,self.rect.y),
				self.Level, self,
				))
			self.nan += 1 
			self.Level.prnt = "Pillbox releases nanite swarms!"

		if self.shield < 0: 
			self.destroy()
			return
		if self.recycle1timer: self.recycle1timer -= 1
		if self.recycle2timer: self.recycle2timer -= 1
		if not self.mtarg or self.mtarg.dead:
			self.mtarg = choice(self.Level.players.sprites())
			self.Level.prnt = "Pillbox targets %s!"%self.mtarg.name
		if self.mtarg is self:
			self.mtarg = None
			return
		
		if not randint(0,(self.shield+1)):
			self.Level.objects.add(Weapons.Polaron(
				AimAt(self, self.mtarg),
				(self.rect.x,self.rect.y),
				self.Level, self,
				))
			if self.shield < 300:
				self.Level.objects.add(Weapons.Polaron(
					AimAt(self, self.mtarg),
					(self.rect.x,self.rect.y),
					self.Level, self,
					))
			if self.shield < 200:
				self.Level.objects.add(Weapons.Polaron(
					AimAt(self, self.mtarg),
					(self.rect.x,self.rect.y),
					self.Level, self,
					))


				
		if self.shield > 300 and not randint(0,(self.shield/4)+1):
			if randint(0,2):
				self.Level.objects.add(Weapons.Plasma(
					AimAt(self, self.mtarg),
					(self.rect.x,self.rect.y),
					self.Level, self,
					))
			else:
				i = 0
				while i < 3:
					self.Level.objects.add(Weapons.Nanoids(
						[1,1],
						(self.rect.x,self.rect.y),
						self.Level, self,
						))
					i += 1
		
		if self.shield < 200 and self.shield > 100 and not randint(0,40):
			dtmp = Weapons.Drone(
				AimAt(self, self.mtarg),
				(self.rect.x,self.rect.y),
				self.Level, self,
				)
			dtmp.secondary = choice([
				Weapons.Plasma, 
				Weapons.Rocket,
				Weapons.Flak,
				Weapons.Polaron,
				Weapons.Floatie, 
				Weapons.Shield,
				Weapons.PillShot
				])
			self.Level.objects.add(dtmp)
			
		if self.shield < 350 and self.shield > 200 and not randint(0,50):
			self.Level.objects.add(Weapons.Rocket(
				AimAt(self, self.mtarg),
				(self.rect.x,self.rect.y),
				self.Level, self,
				))
		

		if self.old_shield > self.shield or (self.mtarg and Dist(self, self.mtarg) < 100):
			try:
				self.Level.prnt = "Pillbox locks in on %s!"%self.lasthitter.player.name
			except:
				print "odd"
			try:
				if self.lasthitter and isinstance(self.lasthitter.player, Player):
					self.mtarg = self.lasthitter.player
			except: 
				self.mtarg = None
			i = 0
			while i < 5:
				self.Level.objects.add(Weapons.Flak(
					AimAt(self, self.mtarg),
					(self.rect.x,self.rect.y),
					self.Level, self,
					))
				if self.shield < 270:
					self.Level.objects.add(Weapons.Goobers(
						AimAt(self, self.mtarg),
						(self.rect.x,self.rect.y),
						self.Level, self,
						))
				i += 1
		self.old_shield = self.shield


class Pepper(Pill):
	override_direction = False
	def __init__(self, keys, id, spawn, Level, name, type=None):
		Player.__init__(self, keys, id, spawn, Level, name, type=None)
		self.image = Graphics_Config.Pepper[0]
		self.shield = 1000
		self.items = []
		self.converted = False
		self.counter = 20
		self.player = self
		
	def update(self):
		if not self.converted:
			self.Level.players.remove(self)
			self.Level.effects.add(self)
			self.targ = choice(self.Level.players.sprites())
			self.Level.prnt = "The Bell Pepper loves %s!"%self.targ.name
			self.converted = True

		if self.targ.shield < 0:
			self.Level.prnt = "The Bell Pepper loves %s!"%self.targ.name
			self.targ = choice(self.Level.players.sprites())
		
		
		if not self.counter: 
			x, y = AimAt(self, self.targ)
			self.speed = [x/5,y/5]
		
		#if not randint(0,600):
		#	self.Level.prnt = "The Bell Pepper Reproduces!"
		#	self.Level.players.add(Pepper(None, -1,
		#		(self.rect.x, self.rect.y),
		#		self.Level, 'Bell Pepper'
		#		))
		try:
			if self.items and not randint(0,70-len(self.items)*2):
				weap = choice(self.items)
				weap.rect.x = self.rect.x
				weap.rect.y = self.rect.y
				weap.speed = [randint(-10,10),randint(-10,10)]
				weap._reg = True
				self.Level.objects.add(weap)
				self.items.remove(weap)
				self.Level.prnt = "The Bell Pepper regurgitates a %s!"%weap.name
		except:
			pass
		for item in spritecollide(self, self.Level.objects, 0):
			if isinstance(item, Weapons.Flak) or isinstance(item, Weapons.Shield) or item.__dict__.has_key('_reg'): continue
			self.items.append(item)
			self.Level.objects.remove(item)
			self.Level.prnt = "The Bell Pepper absorbs a %s"%item.name
			if len(self.items) > 10:
				self.Level.prnt = "The Bell Pepper is getting full..."
			if len(self.items) > 15:
				self.Level.prnt = "The Bell Pepper explodes!"
				for item in self.items:
					item.rect.x = self.rect.x + randint(-64,64)
					item.rect.y = self.rect.y + randint(-64,64)
					item.player = choice(self.Level.players.sprites())
					self.Level.objects.add(item)
				self.destroy()

		
		
		



		self.rect.move_ip(self.speed)
		if self.counter <= 0:
			self.counter = 20
		self.counter -= 1

