#!/usr/bin/python
import pygame
from pygame.locals import *
pygame.init()
pygame.mixer.init()
Gscreen = pygame.display.set_mode([1024,768], 0,16) 

from Data import *
from Data import Objects
from Data.Prefs import keys
from pygame.rect import Rect
from pygame.sprite import spritecollide
from sys import argv, stdout
from time import time, sleep

Gfont = pygame.font.Font(None, 24)
GPlayers = pygame.sprite.RenderPlain()
sleepdel = 0

stattext = pygame.color.Color('0xFFFFFF')

fps = 20

Glevel = Levels.Level('Data/Levels/'+argv[1]+'.level')
Glevel.load()

i = 1
while i <= Glevel.nplayers:
	print i
	try:
		GPlayers.add(Glevel.incarnate(i,
			name=argv[i+1], type=int(argv[i+5]))
			)
	except IndexError:
		print "Usage: circle.py level player1name...player4name controlmodes"
	i += 1

scorestring= "FPS: XX.XX",

Gscreen.blit(Glevel.background, (0,0))
pygame.display.flip()
upcache = []
terminate = True
Oprnt = ''


def msleep(d):
	k = time()+d
	while time() < k:
		pass #Pass the time :)


losing = 0; n = 0

while terminate:
	try:
		Glevel.doscripts()
	except:
		print "Script fault.\n"
	
	if Glevel.mineflag >= 0: Glevel.mineflag -= 1
	stime = time()
	pygame.event.get()
	if pygame.key.get_pressed()[K_ESCAPE]:
		print "\nGame terminated by escape key."
		terminate = False
	for place in upcache: 
		Gscreen.blit(Glevel.background, (place.x,place.y), place)
	upcache = []

	for layer in Glevel.layer_itterator:
		layer.update()
		upcache.extend(layer.draw(Gscreen))
	
	#for person in Glevel.players.sprites():
	#	try:
	#		whostring += '%s: %d (%s %d)  '%(
	#			person.name, person.shield, person.secondary.name, person.scount
	#			)
	#	except:
	#		whostring += '%s: %d ( -NS- )  '%(
	#			person.name, person.shield
	#			)
	if Glevel.prnt != Oprnt:
		Gstats = Gfont.render(Glevel.prnt, 0, stattext)
		Oprnt = Glevel.prnt
	Gscreen.blit(Gstats, (1,1))
	upcache.append(Rect(0,0,16*len(Glevel.prnt),25))
	
	pygame.display.update(upcache)
	
	
	pbound_collide = False
	for boundry in Glevel.bounds.sprites():
		for player in spritecollide(boundry, Glevel.players, 0):
			pbound_collide = True
		if pbound_collide: break

	if pbound_collide:
		for block in Glevel.blocks.sprites():
			if block.cln: block.cln -= 1
			for player in spritecollide(block, Glevel.players, 0):
				block.collide(player)
				block.shield -= 1
				block.lasthitter = player
				if block.shield < 0: block.destroy()
	for player1 in Glevel.players.sprites():
		for player2 in spritecollide(player1, Glevel.players, 0):
			if player1 is player2: continue
			if player1.bouncey or player2.bouncey:
				#player1.speed, player2.speed = (
				#	[player1.speed[0]*-1,player1.speed[1]*-1],
				#	[player2.speed[0]*-1,player2.speed[1]*-1]
				#	)
				player1.speed, player2.speed = player2.speed, player1.speed
				player1.rect.move_ip(player1.speed)
				player2.rect.move_ip(player2.speed)
			else:
				player1.shield, player2.shield = (
					player1.shield-max(player2.shield,0), 
					player2.shield-max(player1.shield,0)
					)
				player1.lastdamage = "a collision with %s"%player2.name
				player2.lastdamage = "a collision with %s"%player1.name
				

	for player in Glevel.players.sprites():
		if player.rect.x+24 > 1024 or player.rect.x < 0 or player.rect.y+24 > 768 or player.rect.y < 0:
			player.speed = [player.speed[1],player.speed[0]*-1]
			player.rect.move_ip(player.speed)
			player.block_collided = True
			Sounds.Hit.play()
			
		for shot in spritecollide(player, Glevel.objects, 0):
			shot.collide(player)
	for player in Glevel.players.sprites():
		for item in spritecollide(player, Glevel.items, 0):
			item.collide(player)

	for objecta in Glevel.objects.sprites():
		for objectb in spritecollide(objecta, Glevel.objects, 0):
			if objecta is objectb or objecta.nhitme or objectb.nhitme: continue
			objecta.destroy(type=1)
			objectb.destroy(type=1)
			
	bound_collide = False
	for boundry in Glevel.bounds.sprites():
		for object in spritecollide(boundry, Glevel.objects, 0):
			bound_collide = True
			break
		if bound_collide: break
	
	if bound_collide:
		for block in Glevel.blocks.sprites():
			for object in spritecollide(block, Glevel.objects,0):
				object.collide(block)
				if block.shield < 0:
					block.destroy()

	if losing > 2 and losing <= 5:
		print "\nMajor lossage detected! Attempting remedial action..."
		eff = Glevel.effects.sprites()
		for effect in eff[0:(len(eff)/2)]:
			effect.kill()
		print "1/2 effects removed."
		stdout.flush()
	elif losing > 5 and fps < 2:
		print "\nEeep! FrameRate Still too low..."
		eff = Glevel.effects.sprites()
		for effect in eff[0:(len(eff)/2)]:
			effect.kill()
		eff = Glevel.objects.sprites()
		for obj in eff[0:(len(eff)/2)]:
			obj.kill()
		print "\nTried to correct lossage..."
		stdout.flush()


	i = 0
	while i < len(Glevel.incarntimes):
		if not Glevel.incarntimes[i]:
			Glevel.objects.add(Objects.WeaponItem(
				Glevel.incarns[i][0], Glevel.incarns[i][1], Glevel.incarns[i][3], Glevel
				))
			Glevel.incarntimes[i] = Glevel.incarns[i][2]
		else:
			Glevel.incarntimes[i] -= 1
		i += 1
				
	erase = '\010'*len(scorestring)
	scorestring = "FPS: %03.2f B:%d Shields: "
	i = 0
	sps = GPlayers.sprites()
	if len(sps) == 1 and Glevel.std:
		Sounds.Win.play()
		print '\n',sps[0].name, "Wins!"
		sleep(3)
		terminate = False
	while i < len(sps):
		scorestring+='%1d: %03d|%1d '%(sps[i].id, sps[i].shield, sps[i].engine)
		i += 1
	if sleepdel: msleep(sleepdel)
	fps = 1/(time()-stime)
	if fps > 30:
		sleepdel = 0.02
	else:
		sleepdel = 0
	if fps < 6:
		losing += 1
	else:
		losing = 0
	
	stdout.flush()
	
	stdout.write(erase+scorestring%(fps,int(pbound_collide)))
	stdout.flush()

print "\nThe game has ended."
